<?php
/**
 * @package J2Store
 * @copyright Copyright (c)2014-17 Ramesh Elamathi / J2Store.org
 * @license GNU GPL v3 or later
 */
// No direct access to this file
defined('_JEXEC') or die;
jimport('joomla.html.html');
jimport('joomla.form.formfield');
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');
require_once JPATH_ADMINISTRATOR . '/components/com_j2store/helpers/j2html.php';
require_once JPATH_ADMINISTRATOR . '/components/com_j2store/helpers/j2store.php';

class JFormFieldWebhook extends JFormFieldList
{

    protected $type = 'webhook';
    var $_element = 'payment_stripecheckout';

    public function getInput()
    {
        require_once JPATH_SITE . "/plugins/j2store/".$this->_element."/library/vendor/autoload.php";
        $html = '';
        $hook_url = trim(JURI::root(),'/').'/index.php?option=com_j2store&view=checkout&task=confirmPayment&orderpayment_type='.$this->_element.'&paction=process&tmpl=component';
        $plugin = JPluginHelper::getPlugin('j2store', $this->_element);
        $params = new JRegistry($plugin->params);
        $mode = $params->get('sandbox', 0);
        if ($mode) {
            // get sandbox credentials
            $publish_key = trim($params->get('stripe_test_secret_key', ''));
            $webhook_id = $params->get('test_webhook_id', '');
        } else {
            $publish_key = trim($params->get('stripe_secret_key', ''));
            $webhook_id = $params->get('webhook_id', '');
        }
        if(!empty($publish_key)){
            \Stripe\Stripe::setApiKey($publish_key);
            $app = JFactory::getApplication();
            $force = $app->input->get('force',0);
            $url = trim(JURI::root(),'/').'/administrator/index.php?option=com_plugins&view=plugin&layout=edit&extension_id='.$plugin->id;
            if (empty($webhook_id) || $force) {
                try {

                    if(!empty($webhook_id)){
                        $endpoint = \Stripe\WebhookEndpoint::retrieve($webhook_id);
                        $endpoint->delete();
                    }

                    $endpoint = \Stripe\WebhookEndpoint::create([
                        "url" => $hook_url,
                        "enabled_events" => ["checkout.session.completed"]
                    ]);
                    if($mode){
                        $params->set('test_webhook_id',$endpoint->id);
                    }else{
                        $params->set('webhook_id',$endpoint->id);
                    }

                    $this->saveParams($params);
                    $app->redirect($url);
                } catch (Exception $e) {
                    if($mode){
                        $params->set('test_webhook_id','');
                    }else{
                        $params->set('webhook_id','');
                    }
                    $this->saveParams($params);
                    $url .= '&force=1';
                    $html = $e->getMessage().'<a href="'.$url.'" class="btn btn-warning">'.JText::_('J2STORE_STRIPECHECKOUT_FORCE').'</a>';
                }
            }else{
                $url .= '&force=1';
                $html .= 'OK <a href="'.$url.'" class="btn btn-warning">'.JText::_('J2STORE_STRIPECHECKOUT_FORCE').'</a>';
            }
        }
        return $html;
    }

    public function saveParams($params){
        try{

            $json = $params->toString();

            $db = JFactory::getDbo ();
            $query = $db->getQuery ( true )->update ( $db->qn ( '#__extensions' ) )->set ( $db->qn ( 'params' ) . ' = ' . $db->q ( $json ) )->where ( $db->qn ( 'element' ) . ' = ' . $db->q ( $this->_element ) )->where ( $db->qn ( 'folder' ) . ' = ' . $db->q ( 'j2store' ) )->where ( $db->qn ( 'type' ) . ' = ' . $db->q ( 'plugin' ) );

            $db->setQuery ( $query );
            $db->execute ();
        }catch (Exception $e){

        }

    }
}
