<?php
/**
 * --------------------------------------------------------------------------------
 *  Payment - Stripe checkout
 * --------------------------------------------------------------------------------
 * @package     Joomla 3.x
 * @subpackage  J2 Store
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2019 J2Store . All rights reserved.
 * @license     GNU GPL v3 or later
 * @link        https://www.j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
defined('_JEXEC') or die;
$ajax_base_url = JRoute::_('index.php');
?>
<?php
$image = $this->params->get('display_image', '');
?>
<?php if(!empty($image)): ?>
    <span class="j2store-payment-image">
				<img class="payment-plugin-image payment_2checkout" src="<?php echo JUri::root().JPath::clean($image); ?>" />
			</span>
    <br />
<?php endif; ?>

<?php echo JText::_($vars->display_name); ?>
<br />
<?php echo JText::_($vars->onbeforepayment_text); ?>
<?php if(isset($vars->error)): ?>
    <span class="j2error"><?php echo $vars->error;?></span>
<?php else: ?>
    <form id="stripe-payment-form" action="<?php echo JRoute::_( "index.php?option=com_j2store&view=checkout" ); ?>" method="post" name="adminForm" enctype="multipart/form-data">

        <input type="button" id="stripe-submit-button" class="button btn btn-primary" value="<?php echo JText::_($vars->button_text); ?>" />
        <input type='hidden' name='order_id' value='<?php echo @$vars->order_id; ?>' />
        <input type='hidden' name='orderpayment_id' value='<?php echo @$vars->orderpayment_id; ?>' />
        <input type='hidden' name='orderpayment_type' value='<?php echo @$vars->orderpayment_type; ?>' />
        <input type='hidden' name='option' value='com_j2store' />
        <input type='hidden' name='view' value='checkout' />
        <input type='hidden' name='task' value='confirmPayment'>
        <input type='hidden' name='paction' value='process'>

        <?php echo JHTML::_( 'form.token' ); ?>

        <br />
        <div class="stripe-payment-errors"></div>
        <br />
        <div class="plugin_error_div">
            <span class="plugin_error"></span>
            <span class="plugin_error_instruction"></span>
        </div>

    </form>

    <script>
        (function ($) {
            var stripe = Stripe('<?php echo $vars->publish_key;?>');
            var button = document.getElementById('stripe-submit-button');
            button.addEventListener('click', function(ev) {
                $(button).attr('disabled', 'disabled');
                ev.preventDefault();
                stripe.redirectToCheckout({
                    // Make the id field from the Checkout Session creation API response
                    // available to this file, so you can provide it as parameter here
                    // instead of the {{CHECKOUT_SESSION_ID}} placeholder.
                    sessionId: '<?php echo $vars->session_id;?>'
                }).then(function (result) {
                    // If `redirectToCheckout` fails due to a browser or network
                    // error, display the localized error message to your customer
                    // using `result.error.message`.
                });
            });
        })(j2store.jQuery);
    </script>
<?php endif; ?>