<?php
/**
 * --------------------------------------------------------------------------------
 *  Payment - Stripe checkout
 * --------------------------------------------------------------------------------
 * @package     Joomla 3.x
 * @subpackage  J2 Store
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2019 J2Store . All rights reserved.
 * @license     GNU GPL v3 or later
 * @link        https://www.j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
// no direct access
defined('_JEXEC') or die;

class plgJ2StorePayment_stripecheckoutInstallerScript
{

    function preflight($type, $parent)
    {
        if (!JComponentHelper::isEnabled('com_j2store')) {
            JError::raiseWarning(null, 'J2Store not found. Please install J2Store before installing this plugin');
            return false;
        }
        jimport('joomla.filesystem.file');
        $version_file = JPATH_ADMINISTRATOR . '/components/com_j2store/version.php';
        if (JFile::exists($version_file)) {
            require_once($version_file);
            // abort if the current J2Store release is older
            if (version_compare(J2STORE_VERSION, '3.2.0', 'lt')) {
                JError::raiseWarning(null, 'You are using an old version of J2Store. Please upgrade to the latest version');
                return false;
            }
        } else {
            JError::raiseWarning(null, 'J2Store not found or the version file is not found. Make sure that you have installed J2Store before installing this plugin');
            return false;
        }
        return true;
    }

}